import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:ios_device_check/ios_device_check.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _value = '';

  @override
  void initState() {
    super.initState();
    generateToken();
  }

  Future<void> generateToken() async {
    String value;

    if (!(await IosDeviceCheck.isSupported)) {
      value = 'Not Supported';
    } else {
      try {
        value = await IosDeviceCheck.generateToken();
      } on PlatformException {
        value = 'Failed to get token.';
      }
    }

    if (!mounted) return;

    setState(() {
      _value = value;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: Text('IosDeviceCheck example'),
        ),
        body: SingleChildScrollView(
          child: Text(_value),
        ),
        floatingActionButton: FloatingActionButton(
          child: Icon(Icons.refresh),
          onPressed: generateToken,
        ),
      ),
    );
  }
}
