#import "IosDeviceCheckPlugin.h"

@implementation IosDeviceCheckPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"com.okadan.ios_device_check"
            binaryMessenger:[registrar messenger]];
  IosDeviceCheckPlugin* instance = [[IosDeviceCheckPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if (@available(iOS 11.0, *)) {
    if ([@"isSupported" isEqualToString:call.method]) {
      result(@([[DCDevice currentDevice] isSupported]));
    } else if ([@"generateToken" isEqualToString:call.method]) {
      [[DCDevice currentDevice] generateTokenWithCompletionHandler:^(NSData *token, NSError *error) {
        if (error == nil) {
          result([token base64EncodedStringWithOptions:0]);
        } else {
          result([FlutterError errorWithCode:@"failed"
                                     message:[error localizedDescription]
                                     details:nil]);
        }
      }];
    } else {
      result(FlutterMethodNotImplemented);
    }
  } else {
    result([FlutterError errorWithCode:@"unavailable"
                               message:@"DeviceCheck is only available on iOS 11.0 or newer."
                               details:nil]);
  }
}

@end
