import 'package:flutter/services.dart';

/// Flutter plugin for iOS DeviceCheck.
///
/// See https://developer.apple.com/documentation/devicecheck
class IosDeviceCheck {
  static const _channel = MethodChannel('com.okadan.ios_device_check');

  /// Boolean value derived from `isSupported` property on `DCDevice`.
  ///
  /// See: https://developer.apple.com/documentation/devicecheck/dcdevice
  static Future<bool> get isSupported async =>
    _channel.invokeMethod('isSupported');

  /// String value derive from `generateToken` method on `DCDevice`.
  ///
  /// See: https://developer.apple.com/documentation/devicecheck/dcdevice
  static Future<String> generateToken() async =>
    _channel.invokeMethod('generateToken');
}